<?php
// 著者：（有）エス技研
// URL ：http://s-giken.net
// プログラム名：パーミッション一括変更ツール・WordPress最適化済バージョン
// バージョン　：1.0.1
// 作成日　　　：2014.08.31
// 更新日　　　：2018.08.21
// ----------------------　注意点　----------------------
// ※個人、法人を問わず自由に利用していただいて構いません。
// 　ただし、著作権は放棄しません。再配布も禁止します。
// ※無名関数を使用しているため、PHP Ver. 5.3以上でしか動きません（たぶん）。

//初期値
$rootdir  = ".";                          // プログラムを動かすフォルダを指定します。
$hidefile = array ( "./chmod_wp.php" );   // リストに表示しないファイルを指定します。

//値の初期化
$err_mess = "";
$filelists = array ();

$chk_php = "";
$chk_css = "";
$chk_gif = "";
$chk_fol = "";
$chk_etc = "";
$chk_ary = array();

$postcheck = array();
$perm      = "";

if ( isset ( $_POST["mode"] ) ) {
	if       ( $_POST["mode"] == "list" ) {

		// ファイルリストの取得
		$filelists = getFileList ( $rootdir );

		// ファイルリスト表示のチェック
		if ( isset ( $_POST["check"] ) ) {
			$postcheck = $_POST["check"];
		} else {
			$err_mess = "ファイルが選択されていません";
		}

	} elseif ( $_POST["mode"] == "chmod" ) {

		// 選択したファイルの取得
		if ( isset ( $_POST["filecheck"] ) ) {
			$filecheck = $_POST["filecheck"];

			if ( $_POST["perm1"] != "--" && $_POST["perm2"] != "--"  && $_POST["perm3"] != "--"  ) {
				$perm = sprintf ( "%04d", $_POST["perm1"] . $_POST["perm2"] . $_POST["perm3"] );

				foreach ( $filecheck as $val ) {
					if ( is_file ( $val ) || is_dir ( $val ) ) {
						if ( !chmod ( $val, octdec ( $perm ) ) ) {
							$err_mess = "パーミッションの変更ができませんでした。ファイル名：" . $val . "<br>\n";;
						}
					}
				}

			} else {
				$err_mess = "パーミッションの値が正しく設定されていません。<br>\n";
			}

		} else {
			$filecheck = array();
			$err_mess = "ファイル／フォルダが選択されていません。<br>\n";
		}


		// ファイルリストの取得
		$filelists = getFileList ( $rootdir );

		// ファイルリスト表示のチェック
		if ( isset ( $_POST["checkbox"] ) ) {
			$postcheck = explode ( ",", $_POST["checkbox"] );
		}

	}


	// ファイルリスト表示のチェック
	if ( isset ( $postcheck ) ) {
		foreach ( $postcheck as $val ) {
			if       ( $val == "php" ) {
				$chk_php   = "checked";
				$chk_ary[] = "php";
			} elseif ( $val == "css" ) {
				$chk_css   = "checked";
				$chk_ary[] = "css";
			} elseif ( $val == "gif" ) {
				$chk_gif   = "checked";
				$chk_ary[] = "gif";
			} elseif ( $val == "fol" ) {
				$chk_fol   = "checked";
				$chk_ary[] = "fol";
			} elseif ( $val == "etc" ) {
				$chk_etc   = "checked";
				$chk_ary[] = "etc";
			}
		}
	}


}




// ファイルリストを取得する関数（車輪の再開発....）
function getFileList ( $dir ) {
	$files = scandir ( $dir );
	$files = array_filter ( $files, function ( $file ) {
		return !in_array ( $file, array ( '.', '..' ) );
	} );

	$list = array();
	foreach ( $files as $file ) {
		$fullpath = rtrim ( $dir, '/' ) . '/' . $file;
		if ( is_file ( $fullpath ) ) {
			$list[] = array ( $fullpath, substr ( sprintf ( '%o', fileperms ( $fullpath ) ), -4), "f" );
		}
		if ( is_dir ( $fullpath ) ) {
			$list = array_merge ( $list, getFileList ( $fullpath ) );
			$list[] = array ( $fullpath, substr ( sprintf ( '%o', fileperms ( $fullpath ) ), -4), "d" );
		}
	}

	return $list;
}



?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<meta http-equiv="Content-Script-Type" content="text/javascript">
<title>パーミッション一括変更ツール（WordPress最適化済）</title>
<style type="text/css">
strong {
  color: #ff0000;
}
</style>

<script language="JavaScript" type="text/javascript">
<!--
var count;
function BoxChecked(check){
	for(count = 0; count < document.form.elements['filecheck[]'].length; count++){
		document.form.elements['filecheck[]'][count].checked = check;    //チェックボックスをON／OFFにする
	}
}
//-->
</script>
</head>
<h1>【パーミッション一括変更ツール（WordPress最適化済）】</h1>
<hr>

<?php
// エラーの表示
if ( $err_mess != "" ) {
	echo '<div><strong>【エラーメッセージ】<br />' . "\n";
	echo $err_mess;
	echo '</strong></div>';
}
?>

<?php
if ( $filelists ) {
	if ( $chk_ary ) {

		echo '<form action="" method="post" name="form">' . "\n";
		echo '<input type="hidden" name="mode"     value="chmod">' . "\n";
		echo '<input type="hidden" name="checkbox" value="' . implode ( ",", $chk_ary ) . '">' . "\n";
		echo '<table id="table-01"><tr><th>　</th><th>ファイル区分</th><th>パーミッション</th><th>ファイル／フォルダ</th></tr>' . "\n";

		foreach ( $filelists as $file ) {
			$changeflg = "0";
			if ( $_POST["mode"] == "chmod" ) {
				if ( in_array ( $file[0], $filecheck ) ) {
					$changeflg = "1";
				}
			}

			if ( !in_array ( $file[0], $hidefile ) ) {
				if       ( preg_match ( '/\.php$/', $file[0] ) && $file[2] == "f" ) {
					if ( in_array ( "php", $chk_ary ) ) {
						echo htmledit ( $file, $changeflg ) ;
					}
				} elseif ( preg_match ( '/\.css|\.scss|\.js$/', $file[0] ) && $file[2] == "f" ) {
					if ( in_array ( "css", $chk_ary ) ) {
						echo htmledit ( $file, $changeflg ) ;
					}
				} elseif ( preg_match ( '/\.gif|\.jpg|\.jpeg|\.png$/', $file[0] ) && $file[2] == "f" ) {
					if ( in_array ( "gif", $chk_ary ) ) {
						echo htmledit ( $file, $changeflg ) ;
					}
				} elseif ( $file[2] == "d" ) {
					if ( in_array ( "fol", $chk_ary ) ) {
						echo htmledit ( $file, $changeflg ) ;
					}
				} else {
					if ( in_array ( "etc", $chk_ary ) ) {
						echo htmledit ( $file, $changeflg ) ;
					}
				}
			}
		}

		echo "</table>\n";

		echo "<br />\n";
		echo '<input type="button" onClick="BoxChecked(true);"  value="全てにチェックを入れる">　' . "\n";
		echo '<input type="button" onClick="BoxChecked(false);" value="全てのチェックを外す"><br />　<br />' . "\n";

		if ( $perm ) {
			echo "設定されたパーミッション：" . $perm . "<br />\n";
		}
		echo "パーミッション：";
		for ( $i = 1; $i <= 3; $i++ ) {
			echo '<select name="perm' . $i . '">' . "\n";
			echo '<option value="--">--</option>' . "\n";
			for ( $ii = 0; $ii <= 7; $ii++ ) {
				echo '<option value="' . $ii . '">' . $ii . "</option>\n";
			}
			echo '</select>' . "\n";
		}

		echo '<br /><input type="submit" name="submit" value="パーミッション変更実行"><br />' . "\n";
		echo "</form>\n";
	}
}



function htmledit ( $file, $changeflg ) {

	$checkbox = '<input type="checkbox" name="filecheck[]" value="' . $file[0] . '">';

	if ( $file[2] == "f" ) {
		$filename = "Files";
	} else {
		$filename = "フォルダ";
	}

	if ( $changeflg ) {
		$changetmp = "<strong>" . $file[1] . "</strong>";
	} else {
		$changetmp = $file[1];
	}

	$html_tmp = "<tr><td>" . $checkbox . "</td><td>" . $filename . "</td><td>" . $changetmp . "</td><td>" . $file[0] . "</td></tr>\n";
	return $html_tmp;
}
?>

<hr>

<form action="" method="post">
<input type="checkbox" name="check[]" value="php" <?php echo $chk_php ?>>PHPファイル　
<input type="checkbox" name="check[]" value="css" <?php echo $chk_css ?>>CSS・JavaScriptファイル　
<input type="checkbox" name="check[]" value="gif" <?php echo $chk_gif ?>>画像ファイル（.gif、.jpg、.jpeg、.png）　
<input type="checkbox" name="check[]" value="fol" <?php echo $chk_fol ?>>フォルダ　
<input type="checkbox" name="check[]" value="etc" <?php echo $chk_etc ?>>それ以外　<br>

<input type="hidden" name="mode" value="list">
<input type="submit" name="submit" value="ファイルリスト表示"><br />
</form>

<hr>

<div>

【機能】<br />
・WordPressのフォルダ内のファイル、フォルダのパーミッションの一覧を表示します。<br />
・表示されたファイルを選択し、パーミッションを変更することができます。<br />
　<br />
【目的】<br />
WordPressのファイル、フォルダのパーミッションを変更し、セキュリティを向上します。<br />
　<br />
【使い方】<br />
１．「ファイルリスト表示」をクリックしてファイルリストを表示させます。<br />
２．表示されたファイルリストからパーミッションを変更するファイルを選択し、パーミッションを入力し、「パーミッション変更実行」をクリックするとパーミッションが変更されます。<br />
　　　注）「パーミッション変更実行」をクリックすると確認なしに処理が実行されます。<br />
　<br />
【注意点】<br />
外部の方がアクセスすると危険ですので、使用した後は削除しておきましょう。<br />
　<br />
【その他】<br />
詳しくは、エス技研ブログ「<a href="http://blog.s-giken.net/158.html" target="_blank">パーミッション（属性）一括変更ツール・WordPress最適化済</a>」をご覧ください。<br />
<br />
<br />
</div>


</body>
</html>
